<div class="page">
    <div class="mat-card-header">
        <div class="mat-card-header-entry"><h1>Protocols</h1></div>
    </div>

    <table
        mat-table
        [dataSource]="dataSource"
        matSort
        multiTemplateDataRows
        class="mat-elevation-z8"
    >
        <ng-container matColumnDef="title">
            <th mat-header-cell *matHeaderCellDef mat-sort-header>Title</th>
            <td mat-cell *matCellDef="let element; let i = dataIndex" (click)="expand(i)" style="cursor: pointer">
                {{ element.protocolInfo.title }}
            </td>
        </ng-container>

        <ng-container matColumnDef="uuid">
            <th mat-header-cell *matHeaderCellDef>Service</th>
            <td mat-cell *matCellDef="let element">
                {{ element.protocolInfo.service.uuid }}
            </td>
        </ng-container>

        <ng-container matColumnDef="owner">
            <th mat-header-cell *matHeaderCellDef>Owner</th>
            <td mat-cell *matCellDef="let element">
                {{ element.protocolInfo.owner }}
            </td>
        </ng-container>

        <ng-container matColumnDef="edit">
            <th mat-header-cell *matHeaderCellDef></th>
            <td mat-cell *matCellDef="let i = dataIndex; let element">
                <div class="edit">
                    <button mat-icon-button (click)="delete(i)">
                        <mat-icon matTooltip="Delete this protocol">delete</mat-icon>
                    </button>
                    <button mat-icon-button (click)="edit(i)">
                        <mat-icon matTooltip="Edit protocol settings">edit</mat-icon>
                    </button>
                </div>
            </td>
        </ng-container>

        <!-- Expanded Row-->
        <ng-container matColumnDef="expandedDetail">
            <td
                mat-cell
                *matCellDef="let element; let i = dataIndex"
                [attr.colspan]="tableColumns.length"
            >
                <div
                    class="expanded-element"
                    [@detailExpand]="selected === i ? 'expanded' : 'collapsed'"
                >
                    <h2>Features</h2>
                    <ng-container *ngFor="let feature of element.protocolInfo.service.features; let featureIndex = index">
                        <h3>Feature: {{feature.identifier}}</h3>
                        <ng-container *ngFor="let command of feature.commands; let commandIndex = index">
                            <h4>Command: {{command.identifier}}</h4>
                            <div class="multi-select">
                                <mat-form-field *ngIf="command.observable === false && command.meta === false" appearance="fill">
                                    <mat-label>Interval</mat-label>
                                    <input [disabled]="true" matInput type="number" [(ngModel)]="command.interval" name="command_interval" placeholder="Interval"/>
                                </mat-form-field>
                                <mat-checkbox [disabled]="true" [(ngModel)]="command.meta" name="command_meta">Meta</mat-checkbox>
                            </div>
                            <ng-container *ngFor="let parameter of command.parameters">
                                <h5>Parameter: {{parameter.identifier}}</h5>
                                <mat-form-field appearance="fill">
                                    <mat-label>Value</mat-label>
                                    <input [disabled]="true" matInput [(ngModel)]="parameter.value" name="parameter_value" placeholder="Value"/>
                                </mat-form-field>
                            </ng-container>
                            <ng-container *ngFor="let response of command.responses">
                                <h5>Response: {{response.identifier}}</h5>
                            </ng-container>
                        </ng-container>
                        <ng-container *ngFor="let property of feature.properties; let propertyIndex = index">
                            <h4>Property: {{property.identifier}}</h4>
                            <div class="multi-select">
                                <mat-form-field *ngIf="property.observable === false && property.meta === false" appearance="fill">
                                    <mat-label>Interval</mat-label>
                                    <input [disabled]="true" matInput type="number" [(ngModel)]="property.interval" name="property_interval" placeholder="Interval"/>
                                </mat-form-field>
                                <mat-checkbox [disabled]="true" [(ngModel)]="property.meta" name="property_meta">Meta</mat-checkbox>
                            </div>
                        </ng-container>
                    </ng-container>

                    <h2>Custom Data</h2>
                    <ng-container *ngFor="let item of element.protocolInfo.custom_data | keyvalue">
                        <h4>Data name: {{item.key}} - Data value: {{item.value}}</h4>
                    </ng-container>

                    <!-- To be included
                    <app-service-detail
                        *ngIf="element.detailsLoaded"
                        [service]="element.service"
                    ></app-service-detail>
                    -->
                </div>
            </td>
        </ng-container>

        <tr mat-header-row *matHeaderRowDef="tableColumns"></tr>
        <tr
            mat-row
            class="row"
            [class.expanded]="i === selected"
            *matRowDef="let row; columns: tableColumns; let i = dataIndex"
        ></tr>
        <tr
            mat-row
            class="expanded-row"
            *matRowDef="let row2; columns: ['expandedDetail']"
        ></tr>

    </table>
</div>
